diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/macros-and-definitions.cmake ns-3.38/build-support/macros-and-definitions.cmake
--- ns-3.37/build-support/macros-and-definitions.cmake	2022-11-01 17:37:24.371394600 -0700
+++ ns-3.38/build-support/macros-and-definitions.cmake	2023-03-16 20:54:23.496868100 -0700
@@ -59,6 +59,12 @@
 
 if(APPLE)
   add_definitions(-D__APPLE__)
+  # cmake-format: off
+  # Configure find_program to search for AppBundles only if programs are not found in PATH.
+  # This prevents Doxywizard from being launched when the Doxygen.app is installed.
+  # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
+  # cmake-format: on
+  set(CMAKE_FIND_APPBUNDLE "LAST")
 endif()
 
 if(WIN32)
@@ -135,6 +141,7 @@
 set(CMAKE_HEADER_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/include/ns3)
 set(THIRD_PARTY_DIRECTORY ${PROJECT_SOURCE_DIR}/3rd-party)
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+link_directories(${CMAKE_OUTPUT_DIRECTORY}/lib)
 
 # Get installation folder default values for each platform and include package
 # configuration macro
@@ -234,33 +241,35 @@
   set(STATIC_LINK_FLAGS)
 endif()
 
-# Search for faster linkers mold and lld, and use them if available
-mark_as_advanced(MOLD LLD)
-find_program(MOLD mold)
-find_program(LLD ld.lld)
-
-# USING_FAST_LINKER will be defined if a fast linker is being used and its
-# content will correspond to the fast linker name
-
-# Mold support was added in GCC 12.1.0
-if(NOT USING_FAST_LINKER
-   AND NOT (${MOLD} STREQUAL "MOLD-NOTFOUND")
-   AND LINUX
-   AND ${GCC}
-   AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 12.1.0)
-)
-  set(USING_FAST_LINKER MOLD)
-  add_link_options("-fuse-ld=mold")
-endif()
+if(${NS3_FAST_LINKERS})
+  # Search for faster linkers mold and lld, and use them if available
+  mark_as_advanced(MOLD LLD)
+  find_program(MOLD mold)
+  find_program(LLD ld.lld)
+
+  # USING_FAST_LINKER will be defined if a fast linker is being used and its
+  # content will correspond to the fast linker name
+
+  # Mold support was added in GCC 12.1.0
+  if(NOT USING_FAST_LINKER
+     AND NOT (${MOLD} STREQUAL "MOLD-NOTFOUND")
+     AND LINUX
+     AND ${GCC}
+     AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 12.1.0)
+  )
+    set(USING_FAST_LINKER MOLD)
+    add_link_options("-fuse-ld=mold")
+  endif()
 
-if(NOT USING_FAST_LINKER AND NOT (${LLD} STREQUAL "LLD-NOTFOUND")
-   AND (${GCC} OR ${CLANG})
-)
-  set(USING_FAST_LINKER LLD)
-  add_link_options("-fuse-ld=lld")
-  if(WIN32)
-    # Clear unsupported linker flags on Windows
-    set(LIB_AS_NEEDED_PRE)
+  if(NOT USING_FAST_LINKER AND NOT (${LLD} STREQUAL "LLD-NOTFOUND")
+     AND (${GCC} OR ${CLANG})
+  )
+    set(USING_FAST_LINKER LLD)
+    add_link_options("-fuse-ld=lld")
+    if(WIN32)
+      # Clear unsupported linker flags on Windows
+      set(LIB_AS_NEEDED_PRE)
+    endif()
   endif()
 endif()
 
@@ -317,6 +326,9 @@
   )
 endmacro()
 
+# Include CMake file with common find_program HINTS
+include(build-support/3rd-party/find-program-hints.cmake)
+
 # function used to search for package and program dependencies than store list
 # of missing dependencies in the list whose name is stored in missing_deps
 function(check_deps package_deps program_deps missing_deps)
@@ -335,7 +347,9 @@
     # here or it won't check other dependencies
     string(TOUPPER ${program} upper_${program})
     mark_as_advanced(${upper_${program}})
-    find_program(${upper_${program}} ${program})
+    find_program(
+      ${upper_${program}} ${program} HINTS ${3RD_PARTY_FIND_PROGRAM_HINTS}
+    )
     if("${${upper_${program}}}" STREQUAL "${upper_${program}}-NOTFOUND")
       list(APPEND local_missing_deps ${program})
     endif()
@@ -465,6 +479,18 @@
     if("${CLANG_TIDY}" STREQUAL "CLANG_TIDY-NOTFOUND")
       message(FATAL_ERROR "Clang-tidy was not found")
     else()
+      if((${CMAKE_VERSION} VERSION_LESS "3.12.0") AND ${NS3_CCACHE}
+         AND (NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
+      )
+        # CMake <3.12 puts CMAKE_CXX_COMPILER_LAUNCHER in the incorrect place
+        # and CCache ends up being unable to cache anything if calling
+        # clang-tidy https://gitlab.kitware.com/cmake/cmake/-/issues/18266
+        message(
+          FATAL_ERROR
+            "The current CMake ${CMAKE_VERSION} won't ccache objects correctly when running with clang-tidy."
+            "Update CMake to at least version 3.12, or disable either ccache or clang-tidy to continue."
+        )
+      endif()
       set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY}")
     endif()
   else()
@@ -479,6 +505,7 @@
         ClangBuildAnalyzer
         GIT_REPOSITORY "https://github.com/aras-p/ClangBuildAnalyzer.git"
         GIT_TAG "47406981a1c5a89e8f8c62802b924c3e163e7cb4"
+        CMAKE_ARGS -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
         INSTALL_COMMAND cmake -E copy_if_different ClangBuildAnalyzer
                         ${PROJECT_BINARY_DIR}
       )
@@ -511,6 +538,7 @@
   else()
     file(GLOB_RECURSE MODULES_CMAKE_FILES src/**/CMakeLists.txt
          contrib/**/CMakeLists.txt examples/**/CMakeLists.txt
+         scratch/**/CMakeLists.txt
     )
     file(
       GLOB
@@ -688,6 +716,20 @@
   )
   list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/build-support/3rd-party")
 
+  set(ENABLE_EIGEN False)
+  if(${NS3_EIGEN})
+    find_package(Eigen3 QUIET)
+
+    if(${EIGEN3_FOUND})
+      set(ENABLE_EIGEN True)
+      add_definitions(-DHAVE_EIGEN3)
+      add_definitions(-DEIGEN_MPL2_ONLY)
+      include_directories(${EIGEN3_INCLUDE_DIR})
+    else()
+      message(${HIGHLIGHTED_STATUS} "Eigen was not found")
+    endif()
+  endif()
+
   # GTK3 Don't search for it if you don't have it installed, as it take an
   # insane amount of time
   if(${NS3_GTK3})
@@ -755,25 +797,35 @@
   set(Python3_EXECUTABLE)
   set(Python3_FOUND FALSE)
   set(Python3_INCLUDE_DIRS)
-  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
-    find_package(Python3 COMPONENTS Interpreter Development)
-  else()
-    # cmake-format: off
-    set(Python_ADDITIONAL_VERSIONS 3.1 3.2 3.3 3.4 3.5 3.6 3.7 3.8 3.9)
-    # cmake-format: on
-    find_package(PythonInterp)
-    find_package(PythonLibs)
+  if(${NS3_PYTHON_BINDINGS})
+    if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
+      find_package(Python3 COMPONENTS Interpreter Development)
+    else()
+      # cmake-format: off
+      set(Python_ADDITIONAL_VERSIONS 3.1 3.2 3.3 3.4 3.5 3.6 3.7 3.8 3.9)
+      # cmake-format: on
+      find_package(PythonInterp)
+      find_package(PythonLibs)
 
-    # Move deprecated results into the FindPython3 resulting variables
-    set(Python3_Interpreter_FOUND ${PYTHONINTERP_FOUND})
-    set(Python3_Development_FOUND ${PYTHONLIBS_FOUND})
-    if(${PYTHONINTERP_FOUND})
-      set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
-      set(Python3_FOUND TRUE)
+      # Move deprecated results into the FindPython3 resulting variables
+      set(Python3_Interpreter_FOUND ${PYTHONINTERP_FOUND})
+      set(Python3_Development_FOUND ${PYTHONLIBS_FOUND})
+      if(${PYTHONINTERP_FOUND})
+        set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
+        set(Python3_FOUND TRUE)
+      endif()
+      if(${PYTHONLIBS_FOUND})
+        set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
+        set(Python3_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS})
+      endif()
     endif()
-    if(${PYTHONLIBS_FOUND})
-      set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
-      set(Python3_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS})
+  else()
+    # If Python was not set yet, use the version found by check_deps
+    check_deps("" "python3" python3_deps)
+    if(python3_deps)
+      message(FATAL_ERROR "Python3 was not found")
+    else()
+      set(Python3_EXECUTABLE ${PYTHON3})
     endif()
   endif()
 
@@ -866,6 +918,37 @@
     endif()
   endif()
 
+  if(${NS3_NINJA_TRACING})
+    if(${CMAKE_GENERATOR} STREQUAL Ninja)
+      include(ExternalProject)
+      ExternalProject_Add(
+        NinjaTracing
+        GIT_REPOSITORY "https://github.com/nico/ninjatracing.git"
+        GIT_TAG "f9d21e973cfdeafa913b83a927fef56258f70b9a"
+        CONFIGURE_COMMAND ""
+        BUILD_COMMAND ""
+        INSTALL_COMMAND ""
+      )
+      ExternalProject_Get_Property(NinjaTracing SOURCE_DIR)
+      set(embed_time_trace)
+      if(${NS3_CLANG_TIMETRACE} AND ${CLANG})
+        set(embed_time_trace --embed-time-trace)
+      endif()
+      add_custom_target(
+        ninjaTrace
+        COMMAND
+          ${Python3_EXECUTABLE} ${SOURCE_DIR}/ninjatracing -a
+          ${embed_time_trace} ${PROJECT_BINARY_DIR}/.ninja_log >
+          ${PROJECT_SOURCE_DIR}/ninja_performance_trace.json
+        DEPENDS NinjaTracing
+      )
+      unset(embed_time_trace)
+      unset(SOURCE_DIR)
+    else()
+      message(FATAL_ERROR "Ninjatracing requires the Ninja generator")
+    endif()
+  endif()
+
   # Disable the below warning from bindings built in debug mode with clang++:
   # "expression with side effects will be evaluated despite being used as an
   # operand to 'typeid'"
@@ -975,63 +1058,13 @@
     add_custom_target(doxygen-no-build COMMAND ${doxygen_missing_msg})
   else()
     # We checked this already exists, but we need the path to the executable
-    find_package(Doxygen QUIET)
-
-    # Get introspected doxygen
-    add_custom_target(
-      run-print-introspected-doxygen
-      COMMAND
-        ${CMAKE_OUTPUT_DIRECTORY}/utils/ns${NS3_VER}-print-introspected-doxygen${build_profile_suffix}
-        > ${PROJECT_SOURCE_DIR}/doc/introspected-doxygen.h
-      COMMAND
-        ${CMAKE_OUTPUT_DIRECTORY}/utils/ns${NS3_VER}-print-introspected-doxygen${build_profile_suffix}
-        --output-text > ${PROJECT_SOURCE_DIR}/doc/ns3-object.txt
-      DEPENDS print-introspected-doxygen
-    )
-    add_custom_target(
-      run-introspected-command-line
-      COMMAND ${CMAKE_COMMAND} -E env NS_COMMANDLINE_INTROSPECTION=..
-              ${Python3_EXECUTABLE} ./test.py --no-build --constrain=example
-      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
-      DEPENDS all-test-targets # all-test-targets only exists if ENABLE_TESTS is
-                               # set to ON
-    )
-
-    file(
-      WRITE ${CMAKE_BINARY_DIR}/introspected-command-line-preamble.h
-      "/* This file is automatically generated by
-  CommandLine::PrintDoxygenUsage() from the CommandLine configuration
-  in various example programs.  Do not edit this file!  Edit the
-  CommandLine configuration in those files instead.
-  */\n"
-    )
-    add_custom_target(
-      assemble-introspected-command-line
-      # works on CMake 3.18 or newer > COMMAND ${CMAKE_COMMAND} -E cat
-      # ${PROJECT_SOURCE_DIR}/testpy-output/*.command-line >
-      # ${PROJECT_SOURCE_DIR}/doc/introspected-command-line.h
-      COMMAND
-        ${cat_command} ${CMAKE_BINARY_DIR}/introspected-command-line-preamble.h
-        ${PROJECT_SOURCE_DIR}/testpy-output/*.command-line >
-        ${PROJECT_SOURCE_DIR}/doc/introspected-command-line.h 2> NULL
-      DEPENDS run-introspected-command-line
-    )
+    set(DOXYGEN_EXECUTABLE ${DOXYGEN})
 
     add_custom_target(
       update_doxygen_version
       COMMAND bash ${PROJECT_SOURCE_DIR}/doc/ns3_html_theme/get_version.sh
       WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
     )
-
-    add_custom_target(
-      doxygen
-      COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_SOURCE_DIR}/doc/doxygen.conf
-      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
-      DEPENDS update_doxygen_version run-print-introspected-doxygen
-              assemble-introspected-command-line
-      USES_TERMINAL
-    )
-
     add_custom_target(
       doxygen-no-build
       COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_SOURCE_DIR}/doc/doxygen.conf
@@ -1039,6 +1072,69 @@
       DEPENDS update_doxygen_version
       USES_TERMINAL
     )
+    # The `doxygen` target only really works if we have tests enabled, so emit a
+    # warning to use `doxygen-no-build` instead.
+    if((NOT ${ENABLE_TESTS}) AND (NOT ${ENABLE_EXAMPLES}))
+      # cmake-format: off
+      set(doxygen_target_requires_tests_msg
+              echo The \\'doxygen\\' target called by \\'./ns3 docs doxygen\\' or \\'./ns3 docs all\\' commands
+              require examples and tests to generate introspected documentation.
+              Enable examples and tests, or use \\'doxygen-no-build\\'.
+              )
+      # cmake-format: on
+      add_custom_target(doxygen COMMAND ${doxygen_target_requires_tests_msg})
+      unset(doxygen_target_requires_tests_msg)
+    else()
+      # Get introspected doxygen
+      add_custom_target(
+        run-print-introspected-doxygen
+        COMMAND
+          ${CMAKE_OUTPUT_DIRECTORY}/utils/ns${NS3_VER}-print-introspected-doxygen${build_profile_suffix}
+          > ${PROJECT_SOURCE_DIR}/doc/introspected-doxygen.h
+        COMMAND
+          ${CMAKE_OUTPUT_DIRECTORY}/utils/ns${NS3_VER}-print-introspected-doxygen${build_profile_suffix}
+          --output-text > ${PROJECT_SOURCE_DIR}/doc/ns3-object.txt
+        DEPENDS print-introspected-doxygen
+      )
+      add_custom_target(
+        run-introspected-command-line
+        COMMAND ${CMAKE_COMMAND} -E env NS_COMMANDLINE_INTROSPECTION=..
+                ${Python3_EXECUTABLE} ./test.py --no-build --constrain=example
+        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+        DEPENDS all-test-targets # all-test-targets only exists if ENABLE_TESTS
+                                 # is set to ON
+      )
+
+      file(
+        WRITE ${CMAKE_BINARY_DIR}/introspected-command-line-preamble.h
+        "/* This file is automatically generated by
+  CommandLine::PrintDoxygenUsage() from the CommandLine configuration
+  in various example programs.  Do not edit this file!  Edit the
+  CommandLine configuration in those files instead.
+  */\n"
+      )
+      add_custom_target(
+        assemble-introspected-command-line
+        # works on CMake 3.18 or newer > COMMAND ${CMAKE_COMMAND} -E cat
+        # ${PROJECT_SOURCE_DIR}/testpy-output/*.command-line >
+        # ${PROJECT_SOURCE_DIR}/doc/introspected-command-line.h
+        COMMAND
+          ${cat_command}
+          ${CMAKE_BINARY_DIR}/introspected-command-line-preamble.h
+          ${PROJECT_SOURCE_DIR}/testpy-output/*.command-line >
+          ${PROJECT_SOURCE_DIR}/doc/introspected-command-line.h 2> NULL
+        DEPENDS run-introspected-command-line
+      )
+
+      add_custom_target(
+        doxygen
+        COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_SOURCE_DIR}/doc/doxygen.conf
+        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+        DEPENDS update_doxygen_version run-print-introspected-doxygen
+                assemble-introspected-command-line
+        USES_TERMINAL
+      )
+    endif()
   endif()
 
   # Now we check for sphinx dependencies
@@ -1071,6 +1167,7 @@
     add_custom_target(sphinx_models COMMAND ${sphinx_missing_msg})
     add_custom_target(sphinx_tutorial COMMAND ${sphinx_missing_msg})
     add_custom_target(sphinx_contributing COMMAND ${sphinx_missing_msg})
+    add_custom_target(sphinx_installation COMMAND ${sphinx_missing_msg})
   else()
     add_custom_target(sphinx COMMENT "Building sphinx documents")
     mark_as_advanced(MAKE)
@@ -1118,6 +1215,7 @@
     sphinx_target(models)
     sphinx_target(tutorial)
     sphinx_target(contributing)
+    sphinx_target(installation)
   endif()
   # end of checking for documentation dependencies and creating targets
 
@@ -1128,9 +1226,8 @@
   if(${NS3_INT64X64} MATCHES "INT128")
     check_cxx_source_compiles(
       "#include <stdint.h>
-       int main(int argc, char **argv)
+       int main()
          {
-            (void)argc; (void)argv;
             if ((uint128_t *) 0) return 0;
             if (sizeof (uint128_t)) return 0;
             return 1;
@@ -1139,9 +1236,8 @@
     )
     check_cxx_source_compiles(
       "#include <stdint.h>
-       int main(int argc, char **argv)
+       int main()
          {
-           (void)argc; (void)argv;
            if ((__uint128_t *) 0) return 0;
            if (sizeof (__uint128_t)) return 0;
            return 1;
@@ -1278,8 +1374,35 @@
         "Clang-tidy is incompatible with precompiled headers. Continuing without them."
       )
     elseif(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
-      set(PRECOMPILE_HEADERS_ENABLED ON)
-      message(STATUS "Precompiled headers were enabled")
+      # If ccache is not enable or was not found, we can continue with
+      # precompiled headers
+      if((NOT ${NS3_CCACHE}) OR ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
+        set(PRECOMPILE_HEADERS_ENABLED ON)
+        message(STATUS "Precompiled headers were enabled")
+      else()
+        # If ccache was found, we need to check if it is ccache >= 4
+        execute_process(COMMAND ${CCACHE} -V OUTPUT_VARIABLE CCACHE_OUT)
+        # Extract ccache version
+        if(CCACHE_OUT MATCHES "ccache version ([0-9\.]*)")
+          # If an incompatible version is found, do not enable precompiled
+          # headers
+          if("${CMAKE_MATCH_1}" VERSION_LESS "4.0.0")
+            set(PRECOMPILE_HEADERS_ENABLED OFF)
+            message(
+              ${HIGHLIGHTED_STATUS}
+              "Precompiled headers are incompatible with ccache ${CMAKE_MATCH_1} and will be disabled."
+            )
+          else()
+            set(PRECOMPILE_HEADERS_ENABLED ON)
+            message(STATUS "Precompiled headers were enabled.")
+          endif()
+        else()
+          message(
+            FATAL_ERROR
+              "Failed to extract the ccache version while enabling precompiled headers."
+          )
+        endif()
+      endif()
     else()
       message(
         STATUS
@@ -1320,10 +1443,15 @@
         <unordered_map>
         <vector>
     )
-    add_library(stdlib_pch OBJECT ${PROJECT_SOURCE_DIR}/build-support/empty.cc)
+    add_library(
+      stdlib_pch${build_profile_suffix} OBJECT
+      ${PROJECT_SOURCE_DIR}/build-support/empty.cc
+    )
     target_precompile_headers(
-      stdlib_pch PUBLIC "${precompiled_header_libraries}"
+      stdlib_pch${build_profile_suffix} PUBLIC
+      "${precompiled_header_libraries}"
     )
+    add_library(stdlib_pch ALIAS stdlib_pch${build_profile_suffix})
 
     add_executable(
       stdlib_pch_exec ${PROJECT_SOURCE_DIR}/build-support/empty-main.cc
@@ -1360,6 +1488,12 @@
     )
     add_subdirectory(${netanim_SOURCE_DIR} ${netanim_BINARY_DIR})
   endif()
+
+  if(${NS3_FETCH_OPTIONAL_COMPONENTS})
+    include(
+      build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake
+    )
+  endif()
 endmacro()
 
 function(set_runtime_outputdirectory target_name output_directory target_prefix)
@@ -1420,6 +1554,17 @@
   endif()
 endfunction(set_runtime_outputdirectory)
 
+function(get_scratch_prefix prefix)
+  # /path/to/ns-3-dev/scratch/nested-subdir
+  set(temp ${CMAKE_CURRENT_SOURCE_DIR})
+  # remove /path/to/ns-3-dev/ to get scratch/nested-subdir
+  string(REPLACE "${PROJECT_SOURCE_DIR}/" "" temp "${temp}")
+  # replace path separators with underlines
+  string(REPLACE "/" "_" temp "${temp}")
+  # save the prefix value to the passed variable
+  set(${prefix} ${temp}_ PARENT_SCOPE)
+endfunction()
+
 function(build_exec)
   # Argument parsing
   set(options IGNORE_PCH STANDALONE)
@@ -1431,6 +1576,13 @@
     "BEXEC" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
   )
 
+  # Resolve nested scratch prefixes without user intervention
+  if("${CMAKE_CURRENT_SOURCE_DIR}" MATCHES "scratch"
+     AND "${BEXEC_EXECNAME_PREFIX}" STREQUAL ""
+  )
+    get_scratch_prefix(BEXEC_EXECNAME_PREFIX)
+  endif()
+
   add_executable(
     ${BEXEC_EXECNAME_PREFIX}${BEXEC_EXECNAME} "${BEXEC_SOURCE_FILES}"
   )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/version-defines-template.h ns-3.38/build-support/version-defines-template.h
--- ns-3.37/build-support/version-defines-template.h	2022-11-01 17:37:24.371394600 -0700
+++ ns-3.38/build-support/version-defines-template.h	2023-03-16 20:54:23.496868100 -0700
@@ -1,4 +1,3 @@
-/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
  * Copyright (c) 2018 Lawrence Livermore National Laboratory
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/.clang-tidy ns-3.38/.clang-tidy
--- ns-3.37/.clang-tidy	2022-11-01 17:37:24.359394800 -0700
+++ ns-3.38/.clang-tidy	2023-03-16 20:54:23.484868000 -0700
@@ -29,17 +29,22 @@
   performance-inefficient-vector-operation,
   performance-trivially-destructible,
   readability-braces-around-statements,
+  readability-container-size-empty,
   readability-duplicate-include,
   readability-isolate-declaration,
+  readability-make-member-function-const,
+  readability-misleading-indentation,
   readability-misplaced-array-index,
   readability-redundant-control-flow,
   readability-redundant-function-ptr-dereference,
   readability-redundant-smartptr-get,
   readability-redundant-string-cstr,
   readability-simplify-subscript-expr,
+  readability-static-accessed-through-instance,
   readability-static-definition-in-anonymous-namespace,
   readability-string-compare,
   readability-uppercase-literal-suffix,
 
 FormatStyle: "file"
-HeaderFilterRegex: ".*h$"
+HeaderFilterRegex: ".*(ns|NS).*/(contrib|examples|src|scratch|utils)/*/.*h"
+UseColor: true
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/CMakeLists.txt ns-3.38/CMakeLists.txt
--- ns-3.37/CMakeLists.txt	2022-11-01 17:37:24.363394700 -0700
+++ ns-3.38/CMakeLists.txt	2023-03-16 20:54:23.488868200 -0700
@@ -3,19 +3,6 @@
 # ##############################################################################
 cmake_minimum_required(VERSION 3.10..3.10)
 
-# Use ccache if available
-mark_as_advanced(CCACHE)
-find_program(CCACHE ccache)
-if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
-  message(STATUS "CCache is enabled.")
-  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
-  execute_process(
-    COMMAND
-      ${CCACHE} --set-config
-      sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
-  )
-endif()
-
 # ##############################################################################
 # Project name                        #
 # ##############################################################################
@@ -66,6 +53,11 @@
 
 # other options
 option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
+option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
+option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
+option(NS3_FETCH_OPTIONAL_COMPONENTS
+       "Fetch Brite, Click and Openflow dependencies" OFF
+)
 option(NS3_GSL "Build with GSL support" ON)
 option(NS3_GTK3 "Build with GTK3 support" ON)
 option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
@@ -74,12 +66,18 @@
 )
 option(NS3_MPI "Build with MPI support" OFF)
 option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
+option(
+  NS3_NINJA_TRACING
+  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
+  OFF
+)
 set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
 option(NS3_PRECOMPILE_HEADERS
        "Precompile module headers to speed up compilation" ON
 )
 option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
 option(NS3_SQLITE "Build with SQLite support" ON)
+option(NS3_EIGEN "Build with Eigen support" ON)
 option(NS3_STATIC "Build a static ns-3 library and link it against executables"
        OFF
 )
@@ -106,6 +104,21 @@
       "List of modules that should have their examples and tests built (e.g. lte;wifi)"
 )
 
+if(${NS3_CCACHE})
+  # Use ccache if available
+  mark_as_advanced(CCACHE)
+  find_program(CCACHE ccache)
+  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
+    message(STATUS "CCache is enabled.")
+    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
+    execute_process(
+      COMMAND
+        ${CCACHE} --set-config
+        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
+    )
+  endif()
+endif()
+
 # Include macros used below
 include(build-support/macros-and-definitions.cmake)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/doxygen.conf ns-3.38/doc/doxygen.conf
--- ns-3.37/doc/doxygen.conf	2022-11-01 17:37:24.371394600 -0700
+++ ns-3.38/doc/doxygen.conf	2023-03-16 20:54:23.500868000 -0700
@@ -262,7 +262,7 @@
 ##   Inferred template parameters are clear from the context:
 ##     template <typename T> void Func (T x);
 ##   Explicit template parameters must be given at the call site:
-##     template <typename T> void Func (void);
+##     template <typename T> void Func ();
 ##   which is called as
 ##     Func<MyClass> ();
 
@@ -2691,3 +2691,7 @@
 # The default value is: YES.
 
 DOT_CLEANUP            = YES
+
+# Disable dark mode in the generated HTML in Doxygen 1.9.6 or greater.
+HTML_COLORSTYLE        = LIGHT
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/doxygen.warnings.report.sh ns-3.38/doc/doxygen.warnings.report.sh
--- ns-3.37/doc/doxygen.warnings.report.sh	2022-11-01 17:37:24.371394600 -0700
+++ ns-3.38/doc/doxygen.warnings.report.sh	2023-03-16 20:54:23.500868000 -0700
@@ -559,6 +559,12 @@
     echo "Filtered Warnings"
     echo "========================================"
     echo "$filterin"
+elif [ "$filter_log_results" != "" ] ; then
+    echo
+    echo
+    echo "Warnings"
+    echo "========================================"
+    echo "$filter_log_results"
 fi
 
 status_report 0 $me
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/installation/Makefile ns-3.38/doc/installation/Makefile
--- ns-3.37/doc/installation/Makefile	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/doc/installation/Makefile	2023-03-16 20:54:23.500868000 -0700
@@ -0,0 +1,165 @@
+# Makefile for Sphinx documentation
+#
+
+# You can set these variables from the command line.
+SPHINXOPTS    =
+SPHINXBUILD   = sphinx-build
+PAPER         =
+BUILDDIR      = build
+
+# Internal variables.
+PAPEROPT_a4     = -D latex_paper_size=a4
+PAPEROPT_letter = -D latex_paper_size=letter
+ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
+
+# Additional variables for figures, not sphinx default:
+DIA = dia
+EPSTOPDF = epstopdf
+FIGURES = source/figures
+IMAGES_EPS = \
+
+IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
+IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}
+
+IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)
+
+.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest
+
+.NOTPARALLEL:
+
+%.eps : %.dia
+	@echo dia $(notdir $<)
+	@$(DIA) -t eps $< -e $@ >/dev/null
+
+%.png : %.dia
+	@echo dia $(notdir $<)
+	@$(DIA) -t png $< -e $@ >/dev/null
+
+%.png : %.eps
+	@echo convert $(notdir $<)
+	@$(CONVERT) $< $@ >/dev/null
+
+%.pdf : %.eps
+	@echo epstopdf $(notdir $<)
+	@$(EPSTOPDF) $< -o=$@ >/dev/null
+	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
+
+help:
+	@echo "Please use \`make <target>' where <target> is one of"
+	@echo "  html       to make standalone HTML files"
+	@echo "  dirhtml    to make HTML files named index.html in directories"
+	@echo "  singlehtml to make a single large HTML file"
+	@echo "  pickle     to make pickle files"
+	@echo "  json       to make JSON files"
+	@echo "  htmlhelp   to make HTML files and a HTML help project"
+	@echo "  qthelp     to make HTML files and a qthelp project"
+	@echo "  devhelp    to make HTML files and a Devhelp project"
+	@echo "  epub       to make an epub"
+	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
+	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
+	@echo "  text       to make text files"
+	@echo "  man        to make manual pages"
+	@echo "  changes    to make an overview of all changed/added/deprecated items"
+	@echo "  linkcheck  to check all external links for integrity"
+	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
+
+clean:
+	-rm -rf $(BUILDDIR)/*
+
+frag: pickle
+	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
+	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
+	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag
+
+html: $(IMAGES)
+	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
+
+dirhtml: $(IMAGES)
+	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."
+
+singlehtml: $(IMAGES)
+	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
+	@echo
+	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."
+
+pickle: $(IMAGES)
+	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
+	@echo
+	@echo "Build finished; now you can process the pickle files."
+
+json: $(IMAGES)
+	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
+	@echo
+	@echo "Build finished; now you can process the JSON files."
+
+htmlhelp: $(IMAGES)
+	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
+	@echo
+	@echo "Build finished; now you can run HTML Help Workshop with the" \
+	      ".hhp project file in $(BUILDDIR)/htmlhelp."
+
+qthelp: $(IMAGES)
+	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
+	@echo
+	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
+	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
+	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
+	@echo "To view the help file:"
+	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"
+
+devhelp: $(IMAGES)
+	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
+	@echo
+	@echo "Build finished."
+	@echo "To view the help file:"
+	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
+	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
+	@echo "# devhelp"
+
+epub: $(IMAGES)
+	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
+	@echo
+	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."
+
+latex: $(IMAGES)
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo
+	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
+	@echo "Run \`make' in that directory to run these through (pdf)latex" \
+	      "(use \`make latexpdf' here to do that automatically)."
+
+latexpdf: $(IMAGES)
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo "Running LaTeX files through pdflatex..."
+	make -C $(BUILDDIR)/latex all-pdf
+	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."
+
+text: $(IMAGES)
+	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
+	@echo
+	@echo "Build finished. The text files are in $(BUILDDIR)/text."
+
+man: $(IMAGES)
+	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
+	@echo
+	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."
+
+changes: $(IMAGES)
+	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
+	@echo
+	@echo "The overview file is in $(BUILDDIR)/changes."
+
+linkcheck: $(IMAGEs)
+	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
+	@echo
+	@echo "Link check complete; look for any errors in the above output " \
+	      "or in $(BUILDDIR)/linkcheck/output.txt."
+
+doctest: $(IMAGES)
+	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
+	@echo "Testing of doctests in the sources finished, look at the " \
+	      "results in $(BUILDDIR)/doctest/output.txt."
